Public Class clsEmploye

    Private mlngIdEmp As Long
    Private mlngNoEmp As Long
    Private mstrNomEmp As String
    Private mstrPrenomEmp As String
    Private mstrDepartement As String
    Private mstrCodeTache As String

    '************************************************************************************
    'Description :  Retourne le nom complet d'un employ et son numro.
    '************************************************************************************
    Public ReadOnly Property NomCompletEmp() As String
        Get
            NomCompletEmp = mstrNomEmp & ", " & mstrPrenomEmp & " (" & mlngNoEmp & ")"
        End Get
    End Property

    Public Property IdEmp() As Long
        Get
            IdEmp = mlngIdEmp
        End Get

    Set(ByVal Value As Long)
      mlngIdEmp = Value
      RechercheEmployeID(mlngIdEmp)
    End Set
  End Property

    Public Property NoEmp() As Long
        Get
            NoEmp = mlngNoEmp
        End Get

        Set(ByVal Value As Long)
      mlngNoEmp = Value
            'mlngNoEmp = 154
            RechercheEmploye(mlngNoEmp)
        End Set
    End Property

    Public Property NomEmp() As String
        Get
            NomEmp = mstrNomEmp
        End Get

        Set(ByVal Value As String)
            mstrNomEmp = Value
        End Set
    End Property

    Public Property PrenomEmp() As String
        Get
            PrenomEmp = mstrPrenomEmp
        End Get

        Set(ByVal Value As String)
            mstrPrenomEmp = Value
        End Set
    End Property

    Public Property Departement() As String
        Get
            Departement = mstrDepartement
        End Get

        Set(ByVal Value As String)
            mstrDepartement = Value

        End Set
    End Property

    Public Property CodeTache() As String
        Get
            CodeTache = mstrCodeTache
        End Get

        Set(ByVal Value As String)
            mstrCodeTache = Value

        End Set
    End Property

    Private Sub RechercheEmploye(ByVal lngNo As Long)
        On Error GoTo err
        Dim con As New oledb.oledbConnection
        Dim commoledb As New oledb.oledbCommand
        Dim datRead As oledb.oledbDataReader

        con.ConnectionString = "Server=handel;Database=intranet;uid=SRV_ID_Employe;pwd=SRV_ID_Employe"
        con.Open()

        commoledb.Connection = con
        commoledb.CommandText = "SELECT Employe.*, Departement.NomDepartement FROM Employe LEFT JOIN Departement ON DepartementEmploye = idDepartement WHERE NoEmploye = " & lngNo
        datRead = commoledb.ExecuteReader
        If datRead.Read = False Then
            mstrNomEmp = "-1"
            mstrPrenomEmp = "-1"
            mlngIdEmp = "-1"
            mstrDepartement = "-1"
            Exit Sub
        End If

        mstrNomEmp = datRead.Item("NomEmploye")
        mstrPrenomEmp = datRead.Item("PrenomEmploye")
        mlngIdEmp = datRead.Item("idEmploye")

        If IsDBNull(datRead.Item("CodeFacturation")) Then
            mstrCodeTache = ""
        Else
            mstrCodeTache = datRead.Item("CodeFacturation")
        End If

        If IsDBNull(datRead.Item("NomDepartement")) Then
            mstrDepartement = ""
        Else
            mstrDepartement = datRead.Item("NomDepartement")
        End If

        datRead.Close()
        datRead = Nothing
        con.Close()
        con = Nothing
        Exit Sub
ERR:
        MsgBox("Une erreur est survenue. Veuillez contacter le Service Informatique si l'erreur se reproduit." & vbNewLine & "Erreur: " & Err.Number & " " & Err.Description & vbNewLine & "Source: clsEmploye.RechercheEmploye" & " Ligne: " & Err.Erl, MsgBoxStyle.Critical, "Erreur...")

    End Sub
    Private Sub RechercheEmployeID(ByVal lngID As Long)
        On Error GoTo ERR
        Dim con As New oledb.oledbConnection
        Dim commoledb As New oledb.oledbCommand
        Dim datRead As oledb.oledbDataReader

        con.ConnectionString = "Server=handel;Database=intranet;uid=SRV_ID_Employe;pwd=SRV_ID_Employe"
        con.Open()

        commoledb.Connection = con
        commoledb.CommandText = "SELECT Employe.*, Departement.NomDepartement FROM Employe LEFT JOIN Departement ON DepartementEmploye = idDepartement WHERE idEmploye = " & lngID
        datRead = commoledb.ExecuteReader

        If datRead.Read = False Then
            mstrNomEmp = "-1"
            mstrPrenomEmp = "-1"
            mlngIdEmp = "-1"
            mstrDepartement = "-1"
            Exit Sub
        End If
        mlngNoEmp = datRead.Item("NoEmploye")
        mstrNomEmp = datRead.Item("NomEmploye")
        mstrPrenomEmp = datRead.Item("PrenomEmploye")
        mstrCodeTache = datRead.Item("CodeFacturation")
        If IsDBNull(datRead.Item("NomDepartement")) Then
            mstrDepartement = ""
        Else
            mstrDepartement = datRead.Item("NomDepartement")
        End If

        datRead.Close()
        datRead = Nothing
        con.Close()
        con = Nothing
        Exit Sub
ERR:
        MsgBox("Une erreur est survenue. Veuillez contacter le Service Informatique si l'erreur se reproduit." & vbNewLine & "Erreur: " & Err.Number & " " & Err.Description & vbNewLine & "Source: clsEmploye.RechercheEmployeID" & " Ligne: " & Err.Erl, MsgBoxStyle.Critical, "Erreur...")

    End Sub
End Class

